/*
This program has been developed by students from the bachelor Computer Science at Utrecht University within the Software Project course.
© Copyright Utrecht University (Department of Information and Computing Sciences)
*/

// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package databaseTypeService

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// DatabaseTypeServiceClient is the client API for DatabaseTypeService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type DatabaseTypeServiceClient interface {
	GetDatabaseType(ctx context.Context, in *DatabaseTypeRequest, opts ...grpc.CallOption) (*DatabaseTypeResponse, error)
}

type databaseTypeServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewDatabaseTypeServiceClient(cc grpc.ClientConnInterface) DatabaseTypeServiceClient {
	return &databaseTypeServiceClient{cc}
}

func (c *databaseTypeServiceClient) GetDatabaseType(ctx context.Context, in *DatabaseTypeRequest, opts ...grpc.CallOption) (*DatabaseTypeResponse, error) {
	out := new(DatabaseTypeResponse)
	err := c.cc.Invoke(ctx, "/DatabaseTypeService/GetDatabaseType", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// DatabaseTypeServiceServer is the server API for DatabaseTypeService service.
// All implementations must embed UnimplementedDatabaseTypeServiceServer
// for forward compatibility
type DatabaseTypeServiceServer interface {
	GetDatabaseType(context.Context, *DatabaseTypeRequest) (*DatabaseTypeResponse, error)
	mustEmbedUnimplementedDatabaseTypeServiceServer()
}

// UnimplementedDatabaseTypeServiceServer must be embedded to have forward compatible implementations.
type UnimplementedDatabaseTypeServiceServer struct {
}

func (UnimplementedDatabaseTypeServiceServer) GetDatabaseType(context.Context, *DatabaseTypeRequest) (*DatabaseTypeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetDatabaseType not implemented")
}
func (UnimplementedDatabaseTypeServiceServer) mustEmbedUnimplementedDatabaseTypeServiceServer() {}

// UnsafeDatabaseTypeServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to DatabaseTypeServiceServer will
// result in compilation errors.
type UnsafeDatabaseTypeServiceServer interface {
	mustEmbedUnimplementedDatabaseTypeServiceServer()
}

func RegisterDatabaseTypeServiceServer(s grpc.ServiceRegistrar, srv DatabaseTypeServiceServer) {
	s.RegisterService(&DatabaseTypeService_ServiceDesc, srv)
}

func _DatabaseTypeService_GetDatabaseType_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DatabaseTypeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DatabaseTypeServiceServer).GetDatabaseType(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/DatabaseTypeService/GetDatabaseType",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DatabaseTypeServiceServer).GetDatabaseType(ctx, req.(*DatabaseTypeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// DatabaseTypeService_ServiceDesc is the grpc.ServiceDesc for DatabaseTypeService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var DatabaseTypeService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "DatabaseTypeService",
	HandlerType: (*DatabaseTypeServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetDatabaseType",
			Handler:    _DatabaseTypeService_GetDatabaseType_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "databaseType.proto",
}
